<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: I2C.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">I2C.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * I2C.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Feb 24, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef MAIN_I2C_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define MAIN_I2C_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;sys/types.h&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;driver/i2c.h&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;driver/gpio.h&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="classI2C.html">   19</a></span>&#160;<span class="keyword">class </span><a class="code" href="classI2C.html">I2C</a> {</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="classI2C.html#a4d371d14b0fcae3b20f22ee8254536b8">   24</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> gpio_num_t <a class="code" href="classI2C.html#a4d371d14b0fcae3b20f22ee8254536b8">DEFAULT_SDA_PIN</a> = GPIO_NUM_25;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="classI2C.html#aece11572688a31925150176f2241e956">   29</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> gpio_num_t <a class="code" href="classI2C.html#aece11572688a31925150176f2241e956">DEFAULT_CLK_PIN</a> = GPIO_NUM_26;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="classI2C.html#a3343eadb26bb775ed15e7b57ae9abd88">   34</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint32_t <a class="code" href="classI2C.html#a3343eadb26bb775ed15e7b57ae9abd88">DEFAULT_CLK_SPEED</a> = 100000;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <a class="code" href="classI2C.html#a7a9a84fccdacb3346ff97d6f3e158850">I2C</a>();</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classI2C.html#a414fa12d9ddd715be6802cd6fbe8d0ed">beginTransaction</a>();</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classI2C.html#ad43e562aaf70eac7acca8fde9f904234">endTransaction</a>();</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    uint8_t <a class="code" href="classI2C.html#aa0b398b4369cf4db773aeb579c3919bc">getAddress</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classI2C.html#a1d9a7d1373a31adf3c281598ea2c9e18">init</a>(uint8_t address, gpio_num_t sdaPin = <a class="code" href="classI2C.html#a4d371d14b0fcae3b20f22ee8254536b8">DEFAULT_SDA_PIN</a>, gpio_num_t sclPin = <a class="code" href="classI2C.html#aece11572688a31925150176f2241e956">DEFAULT_CLK_PIN</a>, uint32_t clkSpeed = <a class="code" href="classI2C.html#a3343eadb26bb775ed15e7b57ae9abd88">DEFAULT_CLK_SPEED</a>, i2c_port_t portNum = I2C_NUM_0, <span class="keywordtype">bool</span> pullup = <span class="keyword">true</span>);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classI2C.html#ac81d33d8192945eb2caa210ae5055851">read</a>(uint8_t* bytes, <span class="keywordtype">size_t</span> length, <span class="keywordtype">bool</span> ack = <span class="keyword">true</span>);</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classI2C.html#ac81d33d8192945eb2caa210ae5055851">read</a>(uint8_t* <span class="keywordtype">byte</span>, <span class="keywordtype">bool</span> ack = <span class="keyword">true</span>);</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classI2C.html#ad3ebfa3204880e4fa60beeba997f357a">scan</a>();</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classI2C.html#ab6ea7b33432cfea858484411741b3bca">setAddress</a>(uint8_t address);</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classI2C.html#a846d50b0bd6b866498f91bfc50b565cc">setDebug</a>(<span class="keywordtype">bool</span> enabled);</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classI2C.html#a4acd5dd262eb4638e81f471a5e605194">slavePresent</a>(uint8_t address);</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classI2C.html#a07463a2babdabbd675a2745fb53650ca">start</a>();</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classI2C.html#ac9a9e5ea511ff86f474866052a7fabf1">stop</a>();</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classI2C.html#a4a8d11dbd76409914f1e6404dacb2073">write</a>(uint8_t <span class="keywordtype">byte</span>, <span class="keywordtype">bool</span> ack = <span class="keyword">true</span>);</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classI2C.html#a4a8d11dbd76409914f1e6404dacb2073">write</a>(uint8_t* bytes, <span class="keywordtype">size_t</span> length, <span class="keywordtype">bool</span> ack = <span class="keyword">true</span>);</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    uint8_t       m_address;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    i2c_cmd_handle_t m_cmd;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordtype">bool</span>             m_directionKnown;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    gpio_num_t     m_sdaPin;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    gpio_num_t     m_sclPin;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    i2c_port_t     m_portNum;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;};</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* MAIN_I2C_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classI2C_html_a07463a2babdabbd675a2745fb53650ca"><div class="ttname"><a href="classI2C.html#a07463a2babdabbd675a2745fb53650ca">I2C::start</a></div><div class="ttdeci">void start()</div><div class="ttdoc">Add an I2C start request to the command stream.</div><div class="ttdef"><b>Definition:</b> I2C.cpp:240</div></div>
<div class="ttc" id="classI2C_html_a7a9a84fccdacb3346ff97d6f3e158850"><div class="ttname"><a href="classI2C.html#a7a9a84fccdacb3346ff97d6f3e158850">I2C::I2C</a></div><div class="ttdeci">I2C()</div><div class="ttdoc">Create an instance of an I2C object.</div><div class="ttdef"><b>Definition:</b> I2C.cpp:25</div></div>
<div class="ttc" id="classI2C_html_a4acd5dd262eb4638e81f471a5e605194"><div class="ttname"><a href="classI2C.html#a4acd5dd262eb4638e81f471a5e605194">I2C::slavePresent</a></div><div class="ttdeci">bool slavePresent(uint8_t address)</div><div class="ttdoc">Determine if the slave is present and responding.</div><div class="ttdef"><b>Definition:</b> I2C.cpp:224</div></div>
<div class="ttc" id="classI2C_html_ad3ebfa3204880e4fa60beeba997f357a"><div class="ttname"><a href="classI2C.html#ad3ebfa3204880e4fa60beeba997f357a">I2C::scan</a></div><div class="ttdeci">void scan()</div><div class="ttdoc">Scan the I2C bus looking for devices.</div><div class="ttdef"><b>Definition:</b> I2C.cpp:181</div></div>
<div class="ttc" id="classI2C_html_a4d371d14b0fcae3b20f22ee8254536b8"><div class="ttname"><a href="classI2C.html#a4d371d14b0fcae3b20f22ee8254536b8">I2C::DEFAULT_SDA_PIN</a></div><div class="ttdeci">static const gpio_num_t DEFAULT_SDA_PIN</div><div class="ttdoc">The default SDA pin.</div><div class="ttdef"><b>Definition:</b> I2C.h:24</div></div>
<div class="ttc" id="classI2C_html_ac81d33d8192945eb2caa210ae5055851"><div class="ttname"><a href="classI2C.html#ac81d33d8192945eb2caa210ae5055851">I2C::read</a></div><div class="ttdeci">void read(uint8_t *bytes, size_t length, bool ack=true)</div><div class="ttdoc">Read a sequence of bytes from the slave.</div><div class="ttdef"><b>Definition:</b> I2C.cpp:134</div></div>
<div class="ttc" id="classI2C_html_a4a8d11dbd76409914f1e6404dacb2073"><div class="ttname"><a href="classI2C.html#a4a8d11dbd76409914f1e6404dacb2073">I2C::write</a></div><div class="ttdeci">void write(uint8_t byte, bool ack=true)</div><div class="ttdoc">Write a single byte to the I2C slave.</div><div class="ttdef"><b>Definition:</b> I2C.cpp:275</div></div>
<div class="ttc" id="classI2C_html_ac9a9e5ea511ff86f474866052a7fabf1"><div class="ttname"><a href="classI2C.html#ac9a9e5ea511ff86f474866052a7fabf1">I2C::stop</a></div><div class="ttdeci">void stop()</div><div class="ttdoc">Add an I2C stop request to the command stream.</div><div class="ttdef"><b>Definition:</b> I2C.cpp:256</div></div>
<div class="ttc" id="classI2C_html_aece11572688a31925150176f2241e956"><div class="ttname"><a href="classI2C.html#aece11572688a31925150176f2241e956">I2C::DEFAULT_CLK_PIN</a></div><div class="ttdeci">static const gpio_num_t DEFAULT_CLK_PIN</div><div class="ttdoc">The default Clock pin.</div><div class="ttdef"><b>Definition:</b> I2C.h:29</div></div>
<div class="ttc" id="classI2C_html_a414fa12d9ddd715be6802cd6fbe8d0ed"><div class="ttname"><a href="classI2C.html#a414fa12d9ddd715be6802cd6fbe8d0ed">I2C::beginTransaction</a></div><div class="ttdeci">void beginTransaction()</div><div class="ttdoc">Begin a new I2C transaction.</div><div class="ttdef"><b>Definition:</b> I2C.cpp:41</div></div>
<div class="ttc" id="classI2C_html_a1d9a7d1373a31adf3c281598ea2c9e18"><div class="ttname"><a href="classI2C.html#a1d9a7d1373a31adf3c281598ea2c9e18">I2C::init</a></div><div class="ttdeci">void init(uint8_t address, gpio_num_t sdaPin=DEFAULT_SDA_PIN, gpio_num_t sclPin=DEFAULT_CLK_PIN, uint32_t clkSpeed=DEFAULT_CLK_SPEED, i2c_port_t portNum=I2C_NUM_0, bool pullup=true)</div><div class="ttdoc">Initialize the I2C interface.</div><div class="ttdef"><b>Definition:</b> I2C.cpp:97</div></div>
<div class="ttc" id="classI2C_html_ab6ea7b33432cfea858484411741b3bca"><div class="ttname"><a href="classI2C.html#ab6ea7b33432cfea858484411741b3bca">I2C::setAddress</a></div><div class="ttdeci">void setAddress(uint8_t address)</div><div class="ttdoc">Set the address of the I2C slave against which we will be working.</div><div class="ttdef"><b>Definition:</b> I2C.cpp:204</div></div>
<div class="ttc" id="classI2C_html"><div class="ttname"><a href="classI2C.html">I2C</a></div><div class="ttdoc">Interface to I2C functions.</div><div class="ttdef"><b>Definition:</b> I2C.h:19</div></div>
<div class="ttc" id="classI2C_html_ad43e562aaf70eac7acca8fde9f904234"><div class="ttname"><a href="classI2C.html#ad43e562aaf70eac7acca8fde9f904234">I2C::endTransaction</a></div><div class="ttdeci">void endTransaction()</div><div class="ttdoc">End an I2C transaction.</div><div class="ttdef"><b>Definition:</b> I2C.cpp:61</div></div>
<div class="ttc" id="classI2C_html_aa0b398b4369cf4db773aeb579c3919bc"><div class="ttname"><a href="classI2C.html#aa0b398b4369cf4db773aeb579c3919bc">I2C::getAddress</a></div><div class="ttdeci">uint8_t getAddress() const</div><div class="ttdoc">Get the address of the I2C slave against which we are working.</div><div class="ttdef"><b>Definition:</b> I2C.cpp:84</div></div>
<div class="ttc" id="classI2C_html_a846d50b0bd6b866498f91bfc50b565cc"><div class="ttname"><a href="classI2C.html#a846d50b0bd6b866498f91bfc50b565cc">I2C::setDebug</a></div><div class="ttdeci">void setDebug(bool enabled)</div><div class="ttdoc">enable or disable debugging.</div><div class="ttdef"><b>Definition:</b> I2C.cpp:214</div></div>
<div class="ttc" id="classI2C_html_a3343eadb26bb775ed15e7b57ae9abd88"><div class="ttname"><a href="classI2C.html#a3343eadb26bb775ed15e7b57ae9abd88">I2C::DEFAULT_CLK_SPEED</a></div><div class="ttdeci">static const uint32_t DEFAULT_CLK_SPEED</div><div class="ttdoc">The default Clock speed.</div><div class="ttdef"><b>Definition:</b> I2C.h:34</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
